﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Operators;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Optimization.Operators.LCS {
  [Item("DefaultRuleOperator", "Description missing")]
  [StorableClass]
  public abstract class DefaultRuleOperator : SingleSuccessorOperator, IDefaultRuleOperator {

    #region Parameter Properties
    public IValueLookupParameter<BoolValue> NichingParameter {
      get { return (IValueLookupParameter<BoolValue>)Parameters["Niching"]; }
    }
    public IValueLookupParameter<IntValue> NichesParameter {
      get { return (IValueLookupParameter<IntValue>)Parameters["Niches"]; }
    }
    public IValueLookupParameter<IGAssistNiche> DefaultClassParameter {
      get { return (IValueLookupParameter<IGAssistNiche>)Parameters["DefaultClass"]; }
    }
    public ILookupParameter<IGAssistProblemData> GAssistNichesProblemDataParameter {
      get { return (ILookupParameter<IGAssistProblemData>)Parameters["GAssistNichesProblemData"]; }
    }
    public ILookupParameter<ItemArray<IGAssistIndividual>> IndividualParameter {
      get { return (ILookupParameter<ItemArray<IGAssistIndividual>>)Parameters["Individual"]; }
    }
    #endregion

    [StorableConstructor]
    protected DefaultRuleOperator(bool deserializing) : base(deserializing) { }
    protected DefaultRuleOperator(DefaultRuleOperator original, Cloner cloner)
      : base(original, cloner) {
    }
    public DefaultRuleOperator()
      : base() {
      Parameters.Add(new ValueLookupParameter<BoolValue>("Niching"));
      Parameters.Add(new ValueLookupParameter<IntValue>("Niches"));
      Parameters.Add(new ValueLookupParameter<IGAssistNiche>("DefaultClass"));
      Parameters.Add(new LookupParameter<IGAssistProblemData>("GAssistNichesProblemData"));
      Parameters.Add(new ScopeTreeLookupParameter<IGAssistIndividual>("Individual"));
    }
  }
}
